class Nodo:

    def __init__(self, value, succ):
        self.value = value
        self.succ = succ


class Coda:

    def __init__(self):
        self.testa = None
        self.coda = None

    def enqueue(self,  value):
        nuovo_nodo = Nodo(value, None)
        if self.coda is None:
            self.coda = nuovo_nodo
            self.testa = nuovo_nodo
        else:
            self.coda.succ = nuovo_nodo
            self.coda = nuovo_nodo

    def dequeue(self):  # assumiamo coda non vuota
        value = self.testa.value
        if self.testa.succ is None:
            self.coda = None
        self.testa = self.testa.succ
        return value

    def empty(self):
        return self.testa is None
